const Meta = imports.gi.Meta;
const Wnck = imports.gi.Wnck;
const Gio  = imports.gi.Gio;
const Utils = imports.misc.extensionUtils.getCurrentExtension().imports.utils; 
const Tweener = imports.ui.tweener;

const Gettext = imports.gettext.domain('toggle_nautilus@kirby33');

const _ = Gettext.gettext;

const Config = imports.misc.config;

const key_bindings = {
    'toggle-nautilus': function() {
        _toggleNautilus();
    }
};

const mySettings = Utils.getSettings();
const NAUTILUS_SCHEMA = 'org.gnome.desktop.default-applications.terminal';

function _toggleNautilus() {
	let win = _getWindowActor();
	
	if (win === 'start') {
		_startNautilus();
		return;
	}
	if (win.is_minimized()){
		win.unminimize(0);
	} else {
		win.minimize();
	}
}

function _startNautilus(){
	let termSettings = new Gio.Settings({ 'schema': NAUTILUS_SCHEMA });
	try {
		imports.misc.util.trySpawnCommandLine('/usr/bin/nautilus');
	} catch(e) {
		logError(e, 'Error launching nautilus');
	}
}

function _getWindowActor(){
	let wins;
	wins = Wnck.Screen.get_default().get_windows();

	let flag_init ;
	let window = 'start';
	flag_init = 'Init';
	wins.forEach(
		function(wind){
			let app_name = wind.get_application().get_name();
			let nautilusString = _("nautilus");
			let initString = _("Init");
			/*global.log(nautilusString);*/
			/*global.log(app_name);*/
			/*global.log(wind);*/

			if ((app_name == nautilusString) && (flag_init == '') ){
				window = wind;
				return;
			}
			if (flag_init == initString){
				flag_init = '';
			}

		}
	);
	return window;
}

function init() {
	Utils.initTranslations("toggle_nautilus@kirby33bg");
}

function enable() {
	for(key in key_bindings) {
		global.display.add_keybinding(key,
			mySettings,
			Meta.KeyBindingFlags.NONE,
			key_bindings[key]
		);
	}
	Wnck.Screen.get_default().force_update();
}

function disable() {
	for(key in key_bindings) {
		global.display.remove_keybinding(key);
	}
}
